# Dynatrace ESA Solution Server

[![forthebadge](https://forthebadge.com/images/badges/made-with-typescript.svg)](https://forthebadge.com)

[![Build status](https://dev.azure.com/github/Atom/_apis/build/status/Atom%20Production%20Branches?branchName=master)](https://dev.azure.com/github/Atom/_build/latest?definitionId=32&branchName=master)
[![Dependency Status](https://david-dm.org/atom/atom.svg)](https://david-dm.org/atom/atom)

The Dynatrace ESA Solution Server is an extendable reverse-proxy for routing users to applications running on your ActiveGates. 

## Assets
- `Router_Node_Full.zip`          (Contains Node and installed node modules.)
- `Router_Node_Minimal.zip`       (Contains Node and project. You will need to run `npm install`.)
- `Router_Standalone_Full.zip`    (Contains project and installed node modules. You will need to install node.)
- `Router_Standalone_Minimal.zip` (Contains project. You will need to install Node and run `npm install`)


## Installation

#### Requirements
- At least one [ActiveGate](https://www.dynatrace.com/support/help/shortlink/activegate-hub) running the [Remote Plugin Module](https://www.dynatrace.com/support/help/shortlink/extensions-hub#activegate-extensions).
- These packages are only available for 64-bit Windows & Linux systems.


### Deploy
Download your preferred [Bundle](#assets) and the UI Upload bundle `Router_Standalone_Minimal`. Install your bundle following the instructions below, and upload the `Router_Standalone_Minimal` bundle into your Dynatrace UI.  


#### Easy Installation: `Router_Node_Full`

This archive contains EVERYTHING you need to get started. Simply extract this in your ActiveGate's plugin directory, load the minimal file in your Dynatrace interface, and get started.

For the other archives, special instructions can be found below.

#### Manual Installation (All Other Bundles)
 
Packages named `Router_Standalone_*` do not have NodeJS bundled. You'll need to install it yourself. 
NodeJS Installations can be found at [Nodejs.org](https://nodejs.org/en/download/).

Packages named `Router_*_Minimal` don't have the node modules bundled. You'll need to do the following to install them.
Go to the `./router` directory and run `npm install`. This requires an internet connection to npmjs.


## Manual Configuration

If you want to get it setup without using the Dynatrace Plugin UI with a custom port or directory, you can manually create a `router.config.json` file in the directory. This will be loaded within 5 minutes and will start the endpoint up.

router.config.json
```json
{
  "title": "My Custom Routed Endpoint",
  "description" : "Someone should put some descriptive information here.",
  "port": 5000,
  "mode": "port",
  "protocol": "https",
  "path": "/custom1"
}
```

This `router.config.json` file will start up a new endpoint in the Router UI that you can load. It will reference the service running on port 5000 on the ActievGate. It will make the endpoint available via the path `https://<ActiveGateAddress>/custom1/`.

Installing Solutions
=====





DSS resource level
GET       /detl/jobs
POST, PUT /detl/jobs
GET       /detl/api/config
POST, PUT /detl/api/config
GET       /detl/api/health


GET       /armory/jobs
POST, PUT /armory/jobs
GET       /armory/api/config
POST, PUT /armory/api/config
GET       /armory/api/health




** DETL and Armory would need to refuse any non-localhost connections


all connections from ::1/localhost/127.0.0.1 do NOT invoke authentication flows
Otherwise we invoke an authentication flow. This will make it such that the internal proxying from the DSS
will route credentials in the request within headers such as 
Authorization: Userid

Solution Server exposes interface ::1:8888 /permission to evaluate a userid and a requested permission -> 'yes' | 'no' 


In router chain/use chain

..
..
Does user have permission X in Sol 1?          ==> To AuthServer
Some protected action

AuthServer
- Is user ID known? (look in headers)
    NO: Redirect to IDP (returnURL is original request)
    YES: Look up user in Vault.
        - Does user have permission X in Sol 1
            NO: reject
            YES: Continue in the chain


TODO
in install.ts

            if (ex.response?.data?.constraintViolations && ex.response?.data?.constraintViolations[0].message == 'new uploaded extension must not have the same version as stored binary.') {
                return { success: true, message: "Plugin already present." };
            }