Solution Server Configuration
=====

#### Configuring a Solution
The DSS provides a user interface to configure a solution. 

Load the `Installed Packages` screen:
![image.png](/.attachments/image-ca2c12c6-ad18-408e-bd5d-37a6cb207c3d.png)

Let's look at all of those tabs:
![image.png](/.attachments/image-37ca2718-5caa-4bcd-af85-0f76b5f3bb73.png)



First, the name of the Configuration `Certificates`:

![image.png](/.attachments/image-b3d97153-d52b-408a-8250-c771947a383a.png)



Next, the underlying Configuration Type `JSON`:

![image.png](/.attachments/image-c96390cd-634b-4c79-87e6-a28ae96bfa49.png) 



Last, we see this button: 

![image.png](/.attachments/image-fb3d3235-1bc5-4523-bfc6-cd6edbad0ddf.png)

This button toggles between Form and Raw edit modes. 


### Form Editing
Form editing uses schema files to generate a configuration UI that enables users to configure settings as they need without directly writing `JSON`. \
At this time our schemas only support the `JSON` format.

![image.png](/.attachments/image-308db73a-2d17-4626-88e2-137bcff94974.png)


### Raw Editing
The Raw editing mode is for when you need to do something the Form can't support, or you might just hate forms, or the configuration file doesn't have a schema.

Our Raw editor supports the common configuration file formats: `JSON` `YML` `INI` `XML`

We provide an interface with [Monaco Editor](https://github.com/Microsoft/monaco-editor) to do raw file editing. It has the same shortcuts as VS-Code (such as CTRL+F and CTRL+G).
`JSON`
![image.png](/.attachments/image-86fad586-2205-4795-8e91-b292e7832eba.png)
`YML`
![image.png](/.attachments/image-b6e93d08-c283-4576-8816-29477ab16ed9.png)
`INI`
![image.png](/.attachments/image-22674096-5ba8-4461-9e51-6735ad6a68d8.png)
`XML`
![image.png](/.attachments/image-a452f942-528e-4993-b3c8-a950b557d39d.png)





