# Inject path with a relative directory to keep all of the python dependencies from conflicting.
# https://stackoverflow.com/questions/3144089/expand-python-search-path-to-other-source

import os
import sys
sys.path[0] = os.path.normpath('./pylib/')

from ruxit.api.base_plugin import RemoteBasePlugin
from ruxit.api.exceptions import ConfigException

import logging
import subprocess
import time
import requests
import json
import socket

logger = logging.getLogger(__name__)

class SolutionServer(RemoteBasePlugin): 
    
    port = '443'

    # def initialize(self, **kwargs):
        # logger.info("Config: %s", self.config)
        # dir = os.path.dirname(os.path.abspath(__file__))


    def query(self, **kwargs):
        # Create group - provide group id used to calculate unique entity id in dynatrace
        #   and display name for UI presentation
        group = self.topology_builder.create_group(identifier="DynatraceESASolutionServer",
                                                   group_name="Dynatrace ESA Solution Server")


        # Create device - provide device id used to calculate unique entity id in dynatrace
        #   and display name for UI presentation
        device = group.create_device(identifier="solution-server" + socket.gethostname(), display_name="ESA Solution Server [" + socket.gethostname() + ']')

        stats = requests.get('https://127.0.0.1:' + self.port + '/api/health', verify=False).json()

        device.absolute(key='runningPlugins', value=stats['runningPlugins'])
        device.absolute(key='crashedPlugins', value=stats['crashedPlugins'])
        device.absolute(key='awaitingConfigPlugins', value=stats['awaitingConfigPlugins'])
        device.absolute(key='extensions', value=stats['extensions'])
