"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const utils_1 = require("../utils/utils");
const shelljs_1 = __importDefault(require("shelljs"));
const fs = __importStar(require("fs"));
const path_1 = __importDefault(require("path"));
const globals_1 = require("../globals");
const router = express_1.default.Router();
router.get('/:id/:file?', (0, utils_1.route)((req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    const id = req.params.id;
    const file = req.params.file;
    let solution = globals_1.solutionFinder.findSolutionById(id);
    if (!solution) {
        yield globals_1.solutionFinder.discover();
        solution = globals_1.solutionFinder.findSolutionById(id);
        if (!solution)
            return res.status(400).send("Solution not found");
    }
    const dir = path_1.default.normalize(__dirname + '/../../../' + solution.config.id + '/log');
    if (!fs.existsSync(dir) || !solution.config.hasLogs)
        return res.status(200).send({});
    if (file) {
        if (!/\.(txt|log)$/.test(file))
            return res.status(400).send("Unknown log file extension");
        const data = fs.readFileSync(dir + '/' + file, { encoding: 'utf8' });
        res.send({ data });
    }
    else {
        // Filter to only show log file extensions.
        const files = shelljs_1.default.ls(dir).filter(f => /\.(txt|log)$/.test(f));
        res.send({ id, files });
    }
})));
router.get('/activegate/:id/:file?', (0, utils_1.route)((req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    const id = req.params.id;
    const file = req.params.file;
    let solution = globals_1.solutionFinder.findSolutionById(id);
    if (!solution) {
        yield globals_1.solutionFinder.discover();
        solution = globals_1.solutionFinder.findSolutionById(id);
        if (!solution)
            return res.status(400).send("Solution not found");
    }
    const dir = path_1.default.normalize(__dirname + '/../../../../../' + +'/log');
    if (!fs.existsSync(dir) || !solution.config.hasLogs)
        return res.status(200).send({});
    if (file) {
        if (!/\.(txt|log)$/.test(file))
            return res.status(400).send("Unknown log file extension");
        const data = fs.readFileSync(dir + '/' + file, { encoding: 'utf8' });
        res.send({ data });
    }
    else {
        // Filter to only show log file extensions.
        const files = shelljs_1.default.ls(dir).filter(f => /\.(txt|log)$/.test(f));
        res.send({ id, files });
    }
})));
module.exports = router;
