"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
const axios_1 = __importDefault(require("axios"));
const https_1 = __importDefault(require("https"));
const Client = (router, options) => {
    router.use((req, res, next) => {
        // Pass if we don't have a session
        if (!req.cookies["connect.sid"])
            return next();
        axios_1.default
            .get(`https://127.0.0.1:${options.port}/authorization`, {
            httpsAgent: new https_1.default.Agent({
                rejectUnauthorized: false
            }),
            headers: {
                Cookie: `connect.sid=` + req.cookies['connect.sid']
            },
        })
            .then(response => {
            const data = response.data;
            // If we have authorizations specified in client mode, then join them with the 
            // authorizations specified from the server.
            const locallyAppliedPermissions = options.authorizations
                ? options.authorizations[data.name]
                : [] || []; // Always default as an empty array.
            req._username = data.name.toLowerCase();
            req._authorizedScopes = data.permissions.concat(locallyAppliedPermissions);
            return next();
        });
    });
};
exports.Client = Client;
