export declare class CacheClusterPrimary {
    private cacheId;
    private cache;
    constructor(cacheId: string, handleMessages?: boolean);
    processMsg(worker: any, msg: any): false | void;
    sendToWorker(worker: any, msg: any, type: any, data: any): void;
}
export declare class CacheClusterPrimaryPM2 extends CacheClusterPrimary {
    constructor(pm2: any, cacheId: string);
}
export declare class CacheClusterWorker<T = any> {
    private cacheId;
    timeoutMs: number;
    private promises;
    private initiated;
    constructor(cacheId: string);
    /**
     *
     * @param key Key at which item is added into cache
     * @param value Value of item that gets added into cache
     * @returns
     */
    store: (key: string | number, value: T) => Promise<boolean>;
    /**
     *
     * @param key Key for item to retrieve from cache
     * @returns
     */
    fetch: (key: string | number) => Promise<T>;
    /**
     *
     * @param key Key for item to delete from cache
     * @returns
     */
    delete: (key: string | number) => Promise<boolean>;
    private promiseId;
    private savePromise;
    private sendToPrimary;
    waitInit(payload: any): void;
    processMsg(msg: any): boolean;
}
