// @ts-nocheck

import cluster from "cluster";
import ipc from 'node-ipc';

export class SharedMemoryCache {
    constructor() {
        ipc.config.id = 'world';
        ipc.config.retry = 1500;

        ipc.serve(
            () => {
                ipc.server.on(
                    'app.message',
                    function (data, socket) {
                        ipc.log('got a message from', (data.id), (data.message));

                        ipc.server.emit(
                            socket,
                            'app.message',
                            {
                                id: ipc.config.id,
                                message: data.message + ' world!'
                            }
                        );

                        // if (messages.hello && messages.goodbye) {
                        //     ipc.log('got all required events, telling clients to kill connection');
                        //     ipc.server.broadcast(
                        //         'kill.connection',
                        //         {
                        //             id: ipc.config.id
                        //         }
                        //     );
                        // }
                    }
                );
            }
        );




        ipc.server.start();
    }
}

export class MemoryCache {

}
