"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const pm2_1 = __importDefault(require("pm2"));
const rate_limiter_flexible_1 = require("rate-limiter-flexible");
const level_cluster_1 = require("@dt-esa/level-cluster");
const fs_1 = __importDefault(require("fs"));
// Create a Rate Limiter shared cluster.
// This one uses IPC on the PM2 bus. 
new rate_limiter_flexible_1.RateLimiterClusterMasterPM2(pm2_1.default);
// Create a shared memory session store.
const sessionStore = new level_cluster_1.SharedSessionStore(6800);
if (!fs_1.default.existsSync(__dirname + '/../data'))
    fs_1.default.mkdirSync(__dirname + '/../data');
sessionStore.createInstance({
    instanceId: "@dynatrace-esa/authorizer",
    cacheOnDisk: true,
    cachePath: __dirname + "/../data/sessionStore"
});
