"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchLogs = void 0;
var fs = require('fs');
var es = require('event-stream');
const MAX_RESULTS = 30;
function findTerm(line, term) {
    return line.indexOf(term) !== -1;
}
const searchLogs = (filePath, term, max_results = MAX_RESULTS) => __awaiter(void 0, void 0, void 0, function* () {
    let line_current = 0;
    let lines_data = [];
    const stream = fs
        .createReadStream(filePath)
        .pipe(es.split())
        .pipe(es.mapSync(function (line) {
        line_current++;
        if (findTerm(line, term)) {
            lines_data.push({ line_number: line_current, line: line });
        }
        if (lines_data.length === max_results) {
            stream.end();
        }
    })
        .on('error', function (err) {
        console.log('Error while reading file.', err);
    })
        .on('end', function () {
        console.log(lines_data);
    }));
});
exports.searchLogs = searchLogs;
module.exports = { searchLogs: exports.searchLogs };
